#define PROGRAM_VERSION 2.2

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <sys/wait.h>
#include <sys/ioctl.h>
#include <sys/types.h>
#include <sys/select.h>
#include <sys/time.h>

#include <stdio.h>
#include <errno.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>

#include <getopt.h>
#include <unistd.h>
#include <termios.h>
#include <fcntl.h>
#include <poll.h>
#include <signal.h>


#define _POSIX_SOURCE 1 /* POSIX compliant source */
#define false 0
#define FALSE 0
#define true 1
#define TRUE 1

#define BUF_LEN 512

//*****************************************************************************
// umisteni hodnot v packetu

#define pos_NP_TA       1
#define pos_SX_SA       2
#define pos_DL          3
#define pos_COMMAND     4
#define pos_EXTENSION   5
#define pos_ADDRH       5               // k adrese se pricita 1 kdyz je extension pouzite
#define pos_ADDRL       6

#define pos_RECV_DATA   4

#define REVA_pos_DIR	0			// < nebo >  smer komunikace
#define REVA_pos_FC		1			// Flagy a prikaz
#define REVA_pos_ID		2			// doubajt ID desky
#define REVA_pos_DL		4			// delka data
#define REVA_pos_DATA	5			// pozice data
#define REVA_POS_CRC8	5			// pozice CRC8 kdyz data_len == 0

volatile int STOP = FALSE;

int wait_flag = TRUE;                  /* TRUE while no signal received */
int fd, c, read_bytes;
unsigned char buf[BUF_LEN];
unsigned char input_buf[BUF_LEN];
int pocitadlo_paketu = 0;
int timeouts = 0;
int checksum_counter = 0;
int first_recv = true;
int prisel_znak = 0;
int is_begin = 0;
int is_lenght = 0;
int is_data = 0;
int last_header = 0;	// posledni hlavicka packetu - pouziva se pro rozliseni opakovani komunikace
int user_logtype = 0;

static unsigned char checksum = 0;
static unsigned int pckt_len = 255;
static unsigned int zobr_len = 0;


char MODEMDEVICE[64];
#define FILENAME_LENGTH 2048
char output_dump_file[FILENAME_LENGTH];
FILE *outfile = NULL;
int is_outfile = 0;
int baud_rate = 0;
int comm_type = 1;		// typ komunikace 0 - nic, 1 - ECMotor, 2 - REVA IO/moduly
int pocet_prenesenych_bajtu = 0;

char *HEX_BIN[] = {
	"0000",
	"0001",
	"0010",
	"0011",
	"0100",
	"0101",
	"0110",
	"0111",
	"1000",
	"1001",
	"1010",
	"1011",
	"1100",
	"1101",
	"1110",
	"1111"
};

//--------------------------------------------------------------------------------
/**
 * nastav stav DTR
 */


void Set_DTR(unsigned short level) {
	int status;
	ioctl(fd, TIOCMGET, &status);
	if (level) {
		status |= TIOCM_DTR;
	}
	else {
		status &= ~TIOCM_DTR;
	}
	ioctl(fd, TIOCMSET, &status);
}

//--------------------------------------------------------------------------------


/***************************************************************************
* signal handler. sets wait_flag to FALSE, to indicate above loop that     *
* characters have been received.                                           *
**************************************************************************/
// static int inp_indx = 0;
volatile int inp_indx = 0;

int predpokladana_delka_paketu = 0;
int sd = 0;
int recv_compelete = 0;

void signal_handler_sigterm(int status) {
	printf("\nPocitadlo prenesenych bajtu: %d\n", pocet_prenesenych_bajtu);
	STOP = TRUE;
}

/**
 * @brief Prozkoumani komunikace ver.2 motoru PMControl
 */

void ReadBufferECM(void) {
	int x;
	static unsigned char checksum = 0;
	static unsigned char header = 0;
	static unsigned int pckt_len = 255;
	static unsigned int zobr_len = 0;
	unsigned int z;

	read_bytes = 0;
	read_bytes = read(fd, buf, BUF_LEN-1);
	if (read_bytes == 0) return;
	pocet_prenesenych_bajtu += read_bytes;
	for (x = 0; x < read_bytes; x++) {
		if (buf[x] == 0x3e || buf[x] == 0x3c) {
			if (!is_data && !is_lenght) {
				is_begin = 1;
				header = buf[x];
			}
		}
		if (is_begin == 1 && is_data == 0) {  // blok zacina jen tehdy neni-li to uprostred dat
			is_begin = 0;
			is_lenght = 1;	// ocekavej delku packetu
			pckt_len = 255;	//max delka packetu
			inp_indx = 0;
		}
		input_buf[inp_indx] = buf[x];
		if ((inp_indx) == pos_DL && is_lenght == 1) {
			is_lenght = 0;
			pckt_len = buf[x] + 1; //delka packetu i se souctem
			zobr_len = pckt_len + 4;	// celkova delka paketu je: pocet dat + soucet + 3byty hlavicka
			is_data = 1;
		}
		if (inp_indx < BUF_LEN) inp_indx++;
		else {
			// buffer preteka zrus co se da
			is_begin = 0;
			is_data = 0;
			is_lenght = 1;	// ocekavej delku packetu
			inp_indx = 0;
			fprintf(outfile, "buffer pretekl\n ");

		}
		if (pckt_len == 0 && is_data == 1) {
			// packet je kompletni - bude se vypisovat
			pocitadlo_paketu++;
			if (last_header != header) {
				fprintf (outfile, "%c ", header);
			} else {
				fprintf(outfile, "\n! ");		// predchozi hlavicka byla stejna - asi opakovana komunikace
			}
			last_header = header;
			checksum = 0;
			for (z = 0; z < zobr_len; z++) {
				if (outfile == stdout) {
					if (z == pos_DL) printf("\033[32m");
					if (z == pos_RECV_DATA && zobr_len > 2 && header == 0x3E) printf("\033[31m");
					if (z == pos_RECV_DATA && header == 0x3C) printf("\033[33m");
					if (z == pos_RECV_DATA + 2) printf("\033[33m");
					if (z == zobr_len - 1) printf("\033[39m");
				} else {
					printf ("Bytes: %6d, Packets: %6d, Timeouts: %6d, Checksums: %6d\r", pocet_prenesenych_bajtu, pocitadlo_paketu, timeouts, checksum_counter);
				}
				checksum += input_buf[z];
				checksum &= 0xFF;
				fprintf(outfile, "%2.2X ", input_buf[z]);
			}
			if ((checksum & 0xFF) != 0) {
				checksum_counter++;
				fprintf(outfile, " err... checksum: %X ", checksum & 0xFF);
			}
			fprintf(outfile, "\n");
			inp_indx = 0;
			is_data = 0;		// nejsou dalsi data
		}
		if (pckt_len > 0) pckt_len--;
	}
}


void ResetRevaComm(void) {
	is_begin = 1;
	inp_indx = 0;
	pckt_len = 255;

	is_data = 0;		// nejsou dalsi data
	is_lenght = 0;
	is_begin = 0;
	inp_indx = 0;

}

void ReadBufferREVA(void) {
	int x;
	unsigned int z;
	read_bytes = 0;
	read_bytes = read(fd, buf, BUF_LEN-1);
	if (read_bytes == -1) {
		// 		printf("READ ERROR\n");
		return;
	}
	if (read_bytes == 0) return;
	pocet_prenesenych_bajtu += read_bytes;
	for (x = 0; x < read_bytes; x++) {
		if (buf[x] == '<' || buf[x] == '>') {
			// 			if (inp_indx == 0) is_begin = 1;
			if (!is_data && !is_lenght) {
				is_begin = 1;
				inp_indx = 0;
				pckt_len = 255;
			}
		}
		if (is_begin == 1 && is_data == 0 && (inp_indx) == 4 ) {  // blok zacina jen tehdy neni-li to uprostred dat
			is_begin = 0;
			is_lenght = 1;	// ocekavej delku packetu
			pckt_len = 255;	//max delka packetu
		}
		input_buf[inp_indx] = buf[x];
		if ((inp_indx) == REVA_pos_DL && is_lenght == 1) {
			is_lenght = 0;
			pckt_len = buf[x] + 1; 		//delka dat packetu i se souctem
			zobr_len = pckt_len + 5;	// celkova delka paketu je: pocet dat + soucet + 5 bytu hlavicka
			is_data = 1;
		}
		if (inp_indx < BUF_LEN) inp_indx++;
		else {
			// buffer preteka zrus co se da
			is_begin = 0;
			is_data = 0;
			is_lenght = 1;	// ocekavej delku packetu
			inp_indx = 0;
			break;
		}
		if (pckt_len == 0 && is_data == 1) {
			// packet je kompletni - bude se vypisovat
			pocitadlo_paketu++;
			if (last_header != input_buf[0]) {
				fprintf (outfile, "%c ", input_buf[0]);
			} else fprintf(outfile, "\n! ");		// predchozi hlavicka byla stejna - asi opakovana komunikace
			last_header = input_buf[0];
			checksum = 0;
			for (z = 0; z < zobr_len; z++) {
				if (outfile == stdout) {
					if (z == REVA_pos_DL) printf("\033[32m");
					if (z == REVA_pos_DATA && zobr_len > 2 && input_buf[0] == 0x3E) printf("\033[31m");
					if (z == REVA_pos_DATA && input_buf[0] == 0x3C) printf("\033[33m");
					if (z == REVA_pos_DATA + 2) printf("\033[33m");
					if (z == zobr_len - 1) printf("\033[39m");
				} else {
					printf ("Bytes: %6d, Packets: %6d, Timeouts: %6d, Checksums: %6d\r", pocet_prenesenych_bajtu, pocitadlo_paketu, timeouts, checksum_counter);
				}
				checksum += input_buf[z];
				checksum &= 0xFF;
				fprintf(outfile, "%2.2X ", input_buf[z]);
			}
			if ((checksum & 0xFF) != 0) {
				checksum_counter++;
				fprintf(outfile, " err... checksum: %X ", checksum & 0xFF);
				fprintf (outfile, "\n pckt_len %d, zobr_len %d, inp_indx %d, \n", pckt_len, zobr_len, inp_indx);

			}
			fprintf(outfile, "\n");
			is_data = 0;		// nejsou dalsi data
			is_lenght = 0;
			is_begin = 0;
			inp_indx = 0;
		}
		if (pckt_len > 0) pckt_len--;
	}
}

void usage(void) {
	printf ("PMControl's EC Motor communication spy. (c)2011-2018 Pavel Vymetálek <pavel@vym.cz>\n");
	printf ("Usage:\ncomm_spy [-v] [-h] [-o] [-d|--device] /dev/serial [-b|--baud baud_rate] [-c|--comm comm_type]\n");
	printf ("\t-v, --version\tShow version info (program and protocol)\n");
	printf ("\t-h, --help\tShow this text\n");
	printf ("\t-b, --baud\tSet the communication speed. 9600Bd or 38400Bd are supported by ECMotor\n");
	printf ("\t-d, --device\tSet the communication device.\n");
	printf ("\t-c, --comm\tSet the communication type. 1 - ECMotor, 2 - REVA IO/Modules\n");
	printf ("\t-o, --outfile\tOutput to file, instead of stdout. Without coloring ESC sequences\n");
}

/**
 * Nacteni parametru prekladu a parametru spusteni
 * @param argc Pocet argumentu
 * @param argv Rezetec argumentu
 */
void TestArgs (int argc, char *argv[])
{
	int args;
	while (1) {
		int option_index = 0;
		static struct option long_options[] = {
 			{"outfile", required_argument, NULL, 'o'},
			{"baud", required_argument, NULL, 'b'},
			{"comm", required_argument, NULL, 'c'},
			{"device", required_argument, NULL, 'd'},
			{"version", no_argument, NULL, 'v'},
			{"help", no_argument, NULL, 'h'},
			{0, 0, 0, 0}
		};
/*
		// 			{"logfile", required_argument, 0, 'L'}, \
		// 			{"coloring", required_argument, NULL, 't'}, \
	*/
// 		c = getopt_long (argc, argv, "t:a:c:p:o:i:c:L:n:d:l:Gh", long_options, &option_index);
		args = getopt_long (argc, argv, "o:b:c:d:vh", long_options, &option_index);
		if (args == -1)
			// konec parametru
			break;

		switch (args) {
			case 'h':
				usage();
				exit(1);
				break;
			case 'c':
				comm_type = atoi(optarg);
				break;
			case 'd':
				strncpy (&MODEMDEVICE[0], optarg, 63);
				break;
			case 'b':
				baud_rate = atoi(optarg);
// 				strncpy (&MODEMDEVICE[0], optarg, 63);
//  				if (user_logtype >= 0)
// 					printf ("Baud rate: %d \n", baud_rate);
				break;
			case 'o':
				strncpy (&output_dump_file[0], optarg, FILENAME_LENGTH-1);
				is_outfile = 1;
				break;
			case 'v':
				printf ("Comm Spy version %0.1f\n", PROGRAM_VERSION);
				printf ("ECMotor communication protocol: ver. 2.00 (comm_type = 1)\n");
				printf ("REVA IO communication protocol: ver. 1.00 (comm_type = 2)\n");
				exit(1);
				break;

			default:
				break;
		}
	}
// 	if (baud_rate != 9600 && baud_rate != 38400) baud_rate = 9600;
/* Done with options.  OPTIND points to first nonoption argument.  */
// 	if (optind < argc) {
// //		printf ("other argument(s):  ");
// 		while (optind < argc){
// //			printf ("unknown parameter: %d:%s \n", optind, argv[optind++]);
// 		}
// 	}
}


//--------------------------------------------------------------------------------

int main(int argc, char *argv[]) {
	struct termios oldtio, newtio;
	struct sigaction saterm;           /* definition of signal action */

 	int result;						// vystupni hodnota od poll

	int z;
	inp_indx = 0;
	for (z = 0; z < BUF_LEN; z++) {
		buf[z] = 0;
		input_buf[z] = 0;
	}
	if (argc == 1) {
	  printf("You must specify the Serial device\n");
	  usage();
	  exit(1);
	}
	TestArgs (argc, argv);
	printf ("Spy device: %s, communication speed is: %d Bd, ", MODEMDEVICE, baud_rate);
	switch (comm_type) {
		case 2:
			printf ("communication type: REVA IO Modules\n");
			break;
		default:
			printf ("communication type: ECMotor\n");
			break;
	}
	if (is_outfile) {
		outfile = fopen (output_dump_file, "a");
		printf("Output file is: %s\n", output_dump_file);
	} else {
		outfile = stdout;
	}

	/* open the device to be non-blocking (read will return immediatly) */
	fd = open(MODEMDEVICE, O_RDWR | O_NOCTTY | O_NONBLOCK);
	if (fd < 0) {
		perror(MODEMDEVICE);
		return(-1);
	}

 	saterm.sa_handler = signal_handler_sigterm;
 	saterm.sa_flags = 0;
 	sigaction(SIGINT, &saterm, NULL);

	tcgetattr(fd, &oldtio); /* save current port settings */
	switch (baud_rate){
		case 150:
			newtio.c_cflag = B150 | CS8 | CLOCAL | CREAD;
			break;
		case 300:
			newtio.c_cflag = B300 | CS8 | CLOCAL | CREAD;
			break;
		case 600:
			newtio.c_cflag = B600 | CS8 | CLOCAL | CREAD;
			break;
		case 1200:
			newtio.c_cflag = B1200 | CS8 | CLOCAL | CREAD;
			break;
		case 2400:
			newtio.c_cflag = B2400 | CS8 | CLOCAL | CREAD;
			break;
		case 4800:
			newtio.c_cflag = B4800 | CS8 | CLOCAL | CREAD;
			break;
		default:
		case 9600:
			newtio.c_cflag = B9600 | CS8 | CLOCAL | CREAD;
			break;
		case 19200:
			newtio.c_cflag = B19200 | CS8 | CLOCAL | CREAD;
			break;
		case 38400:
			newtio.c_cflag = B38400 | CS8 | CLOCAL | CREAD;
			break;
		case 57600:
			newtio.c_cflag = B57600 | CS8 | CLOCAL | CREAD;
			break;
		case 115200:
			newtio.c_cflag = B115200 | CS8 | CLOCAL | CREAD;
			break;
		case 230400:
			newtio.c_cflag = B230400 | CS8 | CLOCAL | CREAD;
			break;
		case 460800:
			newtio.c_cflag = B460800 | CS8 | CLOCAL | CREAD;
			break;
		case 921600:
			newtio.c_cflag = B921600 | CS8 | CLOCAL | CREAD;
			break;
	}

	newtio.c_iflag = 0;
	newtio.c_oflag = 0;
	newtio.c_lflag = 0;
	newtio.c_cc[VMIN] = 1;
	newtio.c_cc[VTIME] = 0;
	tcsetattr(fd, TCSANOW, &newtio);
	tcflush(fd, TCIOFLUSH);

	/* loop while waiting for input. normally we would do something	useful here */
	fd_set rdfs;
	FD_ZERO(&rdfs);
	FD_SET(fd, &rdfs);

	while (STOP == FALSE) {
		result = select(fd + 1, &rdfs, NULL, NULL, NULL);
		if (result && FD_ISSET(fd, &rdfs)) {
			size_t len = 0;
			ioctl(fd, FIONREAD, &len);
			if (STOP) break;
			if (len == 0) {
				perror("Fatal:");
				exit(EXIT_FAILURE);
			}
			switch (comm_type) {
				case 2:
					ReadBufferREVA();
					break;
				default:
					ReadBufferECM();
					break;
			}
		}
	}
	fprintf (outfile, "\nEND OF DUMP\n");
	fclose (outfile);
	/* restore old port settings */
	tcsetattr(fd, TCSANOW, &oldtio);
	tcflush(fd, TCIOFLUSH);
	if (fd) {
		close(fd);
	}
	return EXIT_SUCCESS;
}
